---
type: api
title: Analyze the index disk usage
description: Analyze the disk usage of each field of an index or data stream.
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/operation/operation-indices-disk-usage
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/operation/operation-indices-disk-usage
products:
  - Elasticsearch
---

# Analyze the index disk usage

Availability: 7.15+

## Paths

- `POST` `/{index}/_disk_usage`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/authentication#basicauth)
- [Bearer auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/v8/authentication#bearerauth)

#### Path Parameters

- `index` (union IndexName | [] IndexName)
  Comma-separated list of data streams, indices, and aliases used to limit the request.
It’s recommended to execute this API with a single index (or the latest backing index of a data stream) as the API consumes resources significantly.

## Description

Analyze the disk usage of each field of an index or data stream.
This API might not support indices created in previous Elasticsearch versions.
The result of a small index can be inaccurate as some parts of an index might not be analyzed by the API.

NOTE: The total size of fields of the analyzed shards of the index in the response is usually smaller than the index `store_size` value because some small metadata files are ignored and some parts of data files might not be scanned by the API.
Since stored fields are stored together in a compressed format, the sizes of stored fields are also estimates and can be inaccurate.
The stored size of the `_id` field is likely underestimated while the `_source` field is overestimated.

## Query String Parameters

- `allow_no_indices` (boolean · default: true)
  If false, the request returns an error if any wildcard expression, index alias, or `_all` value targets only missing or closed indices.
This behavior applies even if the request targets other open indices.
For example, a request targeting `foo*,bar*` returns an error if an index starts with `foo` but no index starts with `bar`.
- `expand_wildcards` (string ExpandWildcards · default: open)
  Type of index that wildcard patterns can match.
If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams.
Supports comma-separated values, such as `open,hidden`.

Supported values include:
  - `all`: Match any data stream or index, including hidden ones.
  - `open`: Match open, non-hidden indices. Also matches any non-hidden data stream.
  - `closed`: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  - `hidden`: Match hidden data streams and hidden indices. Must be combined with `open`, `closed`, or `both`.
  - `none`: Wildcard expressions are not accepted.
  Values: `all`, `open`, `closed`, `hidden`, `none`
- `flush` (boolean · default: true)
  If `true`, the API performs a flush before analysis.
If `false`, the response may not include uncommitted data.
- `ignore_unavailable` (boolean · default: false)
  If `true`, missing or closed indices are not included in the response.
- `run_expensive_tasks` (boolean · default: false)
  Analyzing field disk usage is resource-intensive.
To use the API, this parameter must be set to `true`.

## Response

`application/json`

Type: `object`

## Code Examples

#### Console

```console
POST /my-index-000001/_disk_usage?run_expensive_tasks=true
```

#### JavaScript

```javascript
const response = await client.indices.diskUsage({
  index: "my-index-000001",
  run_expensive_tasks: "true",
});
```

#### Python

```python
resp = client.indices.disk_usage(
    index="my-index-000001",
    run_expensive_tasks=True,
)
```

#### curl

```curl
curl -X POST "$ELASTICSEARCH_URL/my-index-000001/_disk_usage?run_expensive_tasks=true" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY"
```

#### Java

```java
client.indices().diskUsage(d -> d
    .index("my-index-000001")
    .runExpensiveTasks(true)
);
```

#### C#

```c#
var response = await client.Indices
    .DiskUsageAsync(indices: new[] { "my-index-000001" }, d1 => d1
        .RunExpensiveTasks(true)
    );
```

#### PHP

```php
$resp = $client->indices()->diskUsage([
    "index" => "my-index-000001",
    "run_expensive_tasks" => "true",
]);
```

#### Ruby

```ruby
response = client.indices.disk_usage(
  index: "my-index-000001",
  run_expensive_tasks: "true"
)
```

